local BuffFrame, CastingBarFrame, UIErrorsFrame, idTweaks, idTweaksModule, idTweaksOptions, Option, ToggleOption, BlizzardUI
do
  local _obj_0 = _G
  BuffFrame, CastingBarFrame, UIErrorsFrame, idTweaks, idTweaksModule, idTweaksOptions = _obj_0.BuffFrame, _obj_0.CastingBarFrame, _obj_0.UIErrorsFrame, _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaksOptions
  Option, ToggleOption = _obj_0.Option, _obj_0.ToggleOption
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      self.options:add_option(Option(self, 'buff_frame', 'Buffs', 'Customize the Buff frame', { }, {
        hide = ToggleOption(self, 'hide', 'Hide', 'Hide the frame')
      }))
      self.options:add_option(Option(self, 'casting_bar_frame', 'CastingBar', 'Customize the Casring Bar Frame frame', { }, {
        hide = ToggleOption(self, 'hide', 'Hide', 'Hide the frame')
      }))
      return self.options:add_option(Option(self, 'errors_frame', 'Error', 'Customize the center screen error messages', { }, {
        out_of_range = ToggleOption(self, 'out_of_range', 'Out of range', 'Out of range'),
        spell_is_not_ready_yet = ToggleOption(self, 'spell_is_not_ready_yet', 'Spell is not ready yet', 'Spell is not ready yet'),
        target_needs_to_be_in_front_of_you = ToggleOption(self, 'target_needs_to_be_in_front_of_you', 'Target needs to be in font of you', 'Target needs to be in front of you'),
        target_too_close = ToggleOption(self, 'target_too_close', 'Target too close', 'Target too close'),
        there_is_nothing_to_attack = ToggleOption(self, 'there_is_nothing_to_attack', 'There is nothing to attack', 'There is nothing to attack'),
        you_are_facing_the_wrong_way = ToggleOption(self, 'you_are_facing_the_wrong_way', 'You are facing the wrong way', 'You are facing the wrong way'),
        you_are_too_far_away = ToggleOption(self, 'you_are_too_far_away', 'You are too far away', 'You are too far away'),
        you_cant_do_that_yet = ToggleOption(self, 'you_cant_do_that_yet', 'You cant do that yet', 'You cant do that yet'),
        you_have_no_target = ToggleOption(self, 'you_have_no_target', 'You have no target', 'You have no target')
      }))
    end,
    check = function(self)
      self:buff_frame_check()
      self:casting_bar_frame_check()
      return self:errors_frame_check()
    end,
    enable = function(self)
      self.buff_frame_hooked = false
      self.casting_bar_frame_hooked = false
      return self:check()
    end,
    disable = function(self)
      self:buff_frame_disable()
      self:casting_bar_frame_disable()
      return self:errors_frame_disable()
    end,
    buff_frame_check = function(self)
      _G.AAAAAA = self.db
      if self.db.buff_frame.hide then
        return self:buff_frame_enable()
      else
        return self:buff_frame_disable()
      end
    end,
    buff_frame_enable = function(self)
      if not (self.ace_module:IsHooked(CastingBarFrame, 'Show')) then
        self.ace_module:SecureHook(BuffFrame, 'Show', function(frame)
          return BuffFrame:Hide()
        end)
        return BuffFrame:Hide()
      end
    end,
    buff_frame_disable = function(self)
      self.ace_module:Unhook(BuffFrame, 'Show')
      return BuffFrame:Show()
    end,
    casting_bar_frame_check = function(self)
      if self.db.casting_bar_frame.hide then
        return self:casting_bar_frame_enable()
      else
        return self:casting_bar_frame_disable()
      end
    end,
    casting_bar_frame_enable = function(self)
      if not (self.ace_module:IsHooked(CastingBarFrame, 'Show')) then
        self.ace_module:SecureHook(CastingBarFrame, 'Show', function(frame)
          return CastingBarFrame:Hide()
        end)
        return CastingBarFrame:Hide()
      end
    end,
    casting_bar_frame_disable = function(self)
      return self.ace_module:Unhook(CastingBarFrame, 'Show')
    end,
    errors_frame_check = function(self)
      if self.db.errors_frame.enabled then
        return self:errors_frame_enable()
      else
        return self:errors_frame_disable()
      end
    end,
    errors_frame_enable = function(self)
      local hooks = self.ace_module.hooks
      local add_message
      add_message = function(frame, message, red, green, blue, message_id, hold_time)
        local found = false
        for k, v in pairs(self.db.errors_frame) do
          local option = self.options.args.errors_frame.args[k]
          if v and option and message == option.name then
            found = true
          end
        end
        if not found then
          return hooks[frame].AddMessage(frame, message, red, green, blue, message_id, hold_time)
        end
      end
      return self.ace_module:RawHook(UIErrorsFrame, 'AddMessage', add_message, true)
    end,
    errors_frame_disable = function(self)
      return self.ace_module:Unhook(UIErrorsFrame, 'AddMessage')
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      return _class_0.__parent.__init(self, addon, 'BlizzardUI', 'AceConsole-3.0', 'AceEvent-3.0', 'AceHook-3.0')
    end,
    __base = _base_0,
    __name = "BlizzardUI",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  BlizzardUI = _class_0
end
return idTweaks:add_module(BlizzardUI(idTweaks))
