local *

{
  :LibStub
  :idTweaks
  :idTweaksUtils
  :idTweaksOptions
} = _G
{ :Option, :ToggleOption } = idTweaksOptions
{ :split, :join } = idTweaksUtils.string

AceConfig = LibStub 'AceConfig-3.0'
AceConfigDialog = LibStub 'AceConfigDialog-3.0'

class Module
  new: (addon, name, ...) =>
    -- print "Module#new:#{name}"

    @addon = addon
    @name = name

    @ace_module = @addon.ace_addon\NewModule name, ...

    @ace_module.OnInitialize = ->
      -- print "Module#new:#{name}:ace_module.OnInitialize"

      @set_database!
      @set_options!
      @initialize!

    @ace_module.OnEnable = ->
      -- print "Module#new:#{name}:ace_module.OnEnable"

      @check!

    @ace_module.OnDisable = ->
      -- print "Module#new:#{name}:ace_module.OnDisable"

      @disable!

  set_database: =>
    -- print "Module#set_database:#{@name}"

    @addon.db.profile[@name] = @addon.db.profile[@name] or {}
    @db = @addon.db.profile[@name]

  set_options: =>
    -- print "Module#set_options:#{@name}"

    @options = Option @, @name, @name, @name, {},
      enabled: ToggleOption @, 'enabled', 'Enabled', 'Enables / Disables the Module'

    @addon.options\add_option @options

  initialize: =>
    -- print "Module#initialize:#{@name}"

  check: =>
    -- print "Module#check:#{@name}"

    enabled_option = @options\get_option 'enabled'
    is_enabled = enabled_option\get!

    if is_enabled
      @enable!
      @positioning!
    else
      @disable!

  enable: =>
    -- print "Module#enable:#{@name}"

  positioning: =>
    -- print "Module#positioning:#{@name}"

  disable: =>
    -- print "Module#disable:#{@name}"

_G.idTweaksModule = Module
